#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "userfuncts.h"

static char Buffer[1000];


GtkRuler *HRuler,*VRuler;
double XPos,YPos;
GtkDrawingArea *LevelDrawingArea,*MachineDrawingArea;
GdkPixmap *LevelPixmap=NULL,*MachinePixmap=NULL;

static void Compute_Sz_Window()
{
  GtkWidget *w;

  w=create_window3();
  gtk_widget_show(w);

}

static void New_LevelCurve_Window()
{
  GtkWidget *w;

  w=create_window2();
  gtk_widget_show(w);

}

void
on_hruler_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
  HRuler=(GtkRuler *)widget;
}


void
on_vruler_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
  VRuler=(GtkRuler *)widget;
}


void
on_levelcurve1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_levelcurve_new_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  New_LevelCurve_Window();
}


void
on_levelcurve_properties_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GLevelCurveProperties();
}


void
on_levelcurve_view_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}






void
on_NewLevelCurve_OK_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkTable *table1=(GtkTable *)user_data;
  GList *tmp;
  GtkTableChild *w;
  float SplitPrec,SigmaMinPrec,MeshSize,LevelCurve,Re,Im;
  long SigmaMinMaxIt;
  int Slices;
  char Method;
  char Sym;

  tmp=g_list_first(table1->children);
  while(tmp)
    {
      w=(GtkTableChild *) tmp->data;
      if (GTK_IS_ENTRY(w->widget))
	{
	  if (strcmp(w->widget->name,"SplitPrec")==0)
	    if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		       "%f",&SplitPrec)!=1)
	      return;
	  if (strcmp(w->widget->name,"SigmaMinMaxIt")==0)
	    if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%ld",&SigmaMinMaxIt)!=1)
	      return;
	  if (strcmp(w->widget->name,"SigmaMinPrec")==0)
	    if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%f",&SigmaMinPrec)!=1)
	      return;
	  if (strcmp(w->widget->name,"MeshSize")==0)
	    if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%f",&MeshSize)!=1)
	      return;
	  if (strcmp(w->widget->name,"LevelCurve")==0)
	    if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%f",&LevelCurve)!=1)
	      return;
	  if (strcmp(w->widget->name,"InternalPoint")==0)
	    if (ProcessComplex((char *) gtk_entry_get_text(GTK_ENTRY(w->widget)),&Re,&Im)==-1)
	      return;
	  if (strcmp(w->widget->name,"Slices")==0)
	    if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%d",&Slices)!=1)
	      return;
	}
      if (GTK_IS_COMBO(w->widget))
	if (strcmp(w->widget->name,"combo1")==0)
	  Method=* gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(w->widget)->entry));
	else
	  if (strcmp(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(w->widget)->entry)),"No")==0)
	    Sym=0;
	  else
	    Sym=1;
      tmp=g_list_next(tmp);
    }
  CreateLevelCurve(Re,Im,LevelCurve,MeshSize,Method,SigmaMinPrec,SigmaMinMaxIt,SplitPrec,Sym,Slices);
}



void
on_NewLevelCurve_Cancel_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy((GtkWidget *)user_data);
}



void
on_Compute_Sz_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkTable *table2=(GtkTable *)user_data;
  GList *tmp;
  GtkTableChild *w;
  float SigmaMinPrec,Re,Im;
  long SigmaMinMaxIt;
  char Method;

  tmp=g_list_first(table2->children);
  while(tmp)
    {
      w=(GtkTableChild *) tmp->data;
      if (GTK_IS_ENTRY(w->widget))
	{
	  if (strcmp(w->widget->name,"MaxIteration")==0)
	    if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		       "%ld",&SigmaMinMaxIt)!=1)
	      return;
	  if (strcmp(w->widget->name,"Precision")==0)
	    if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%f",&SigmaMinPrec)!=1)
	      return;
	  if (strcmp(w->widget->name,"Complexz")==0)
	    if (ProcessComplex((char *) gtk_entry_get_text(GTK_ENTRY(w->widget)),&Re,&Im)==-1)
	      return;
	}
      if (GTK_IS_COMBO(w->widget))
	Method=* gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(w->widget)->entry));
      tmp=g_list_next(tmp);
    }
  Compute_Sz(Re,Im,Method,SigmaMinPrec,SigmaMinMaxIt);
}


void
on_Compute_Sz_Cancel_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy((GtkWidget *)user_data);
}


void
on_compute_Sz_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  Compute_Sz_Window();
}

gboolean
on_MouseMove_event_updateLabel         (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
  HRuler->position=XPos=HRuler->lower+event->x*(HRuler->upper-HRuler->lower)/widget->allocation.width;
  gtk_ruler_draw_pos(HRuler);
  VRuler->position=YPos=VRuler->lower+event->y*(VRuler->upper-VRuler->lower)/widget->allocation.height;
  gtk_ruler_draw_pos(VRuler);
 sprintf(Buffer,"X=%.4f,Y=%.4f",XPos,YPos);
  gtk_label_set_text(GTK_LABEL(user_data),Buffer);
  return FALSE;
}

void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *w;
  w=create_fileselection2 ();
  gtk_widget_show(w);
}

void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *w;
  w=create_fileselection1 ();
  gtk_widget_show(w);
}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


gboolean
on_ConnectMainMaster_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  if (Connect2MainMaster())
    {
      gtk_widget_show(GTK_WIDGET(user_data));
      gtk_widget_hide(widget);
    }
  return FALSE;
}


gboolean
on_DisconnectMainMaster_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  if (DisconnectFromMainMaster())
    {
      gtk_widget_show(GTK_WIDGET(user_data));
      gtk_widget_hide(widget);
    }
  return FALSE;
}


void on_Connect_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *w;

  w=create_dialog1();
  gtk_widget_show(w);

}


void
on_ConnectConfigureHostname_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
  SetHostName(gtk_entry_get_text(GTK_ENTRY(user_data)));
}


void
on_ConnectConfigurePort_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  SetHostPort(gtk_entry_get_text(GTK_ENTRY(user_data)));
}


void
on_ConnectConfigureCancel_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy((GtkWidget *)user_data);
}






void ZoomIn()
{
  double width=0.25*(HRuler->upper-HRuler->lower);
  double height=0.25*(VRuler->upper-VRuler->lower);

  HRuler->lower=XPos-width;
  HRuler->upper=XPos+width;
  gtk_widget_hide((GtkWidget *)HRuler);
  gtk_ruler_draw_ticks(HRuler);
  gtk_ruler_draw_pos(HRuler);
  gtk_widget_show((GtkWidget *)HRuler);

  VRuler->lower=YPos-height;
  VRuler->upper=YPos+height;
  gtk_widget_hide((GtkWidget *)VRuler);
  gtk_ruler_draw_ticks(VRuler);
  gtk_ruler_draw_pos(VRuler);
  gtk_widget_show((GtkWidget *)VRuler);
}


void ZoomOut()
{
  double width=HRuler->upper-HRuler->lower;
  double height=VRuler->upper-VRuler->lower;

  HRuler->lower=XPos-width;
  HRuler->upper=XPos+width;      
  gtk_widget_hide((GtkWidget *)HRuler);
  gtk_ruler_draw_ticks(HRuler);
  gtk_ruler_draw_pos(HRuler);
  gtk_widget_show((GtkWidget *)HRuler);

  VRuler->lower=YPos-height;
  VRuler->upper=YPos+height;      
  gtk_widget_hide((GtkWidget *)VRuler);
  gtk_ruler_draw_ticks(VRuler);
  gtk_ruler_draw_pos(VRuler);
  gtk_widget_show((GtkWidget *)VRuler);

}


void
on_Compute_Sz_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


static void (*Action)()=NULL;

gboolean on_MouseClick_event                    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  if (Action && event->button==1)
    (*Action)();
  return FALSE;
}

void
on_drawingcurvearea_realize            (GtkWidget       *widget,
                                        gpointer         user_data)
{
  LevelDrawingArea=(GtkDrawingArea *)widget;
  RedrawAllCurves();
}


void
on_drawingmachinearea_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{
  MachineDrawingArea=(GtkDrawingArea *)widget;
}


gboolean
on_Hruler_button_press                 (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  switch (event->button)
    {
    case 1:
      {
	double width=HRuler->upper-HRuler->lower;
	
	HRuler->lower=HRuler->lower-width/5;
	HRuler->upper=HRuler->lower+width;      
	gtk_widget_hide((GtkWidget *)HRuler);
	gtk_ruler_draw_ticks(HRuler);
	gtk_ruler_draw_pos(HRuler);
	gtk_widget_show((GtkWidget *)HRuler);
	break;
      }
    case 3:
      {
	double width=HRuler->upper-HRuler->lower;
	
	HRuler->upper=HRuler->upper+width/5;
	HRuler->lower=HRuler->upper-width;      
	gtk_widget_hide((GtkWidget *)HRuler);
	gtk_ruler_draw_ticks(HRuler);
	gtk_ruler_draw_pos(HRuler);
	gtk_widget_show((GtkWidget *)HRuler);
	break;
      }

    }
  return FALSE;
}


gboolean
on_Vruler_button_press                 (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
   switch (event->button)
    {
    case 1:
      {
	double height=VRuler->upper-VRuler->lower;
	
	VRuler->lower=VRuler->lower-height/5;
	VRuler->upper=VRuler->lower+height;      
	gtk_widget_hide((GtkWidget *)VRuler);
	gtk_ruler_draw_ticks(VRuler);
	gtk_ruler_draw_pos(VRuler);
	gtk_widget_show((GtkWidget *)VRuler);
	break;
      }
    case 3:
      {
	double height=VRuler->upper-VRuler->lower;
	
	VRuler->upper=VRuler->upper+height/5;
	VRuler->lower=VRuler->upper-height;      
	gtk_widget_hide((GtkWidget *)VRuler);
	gtk_ruler_draw_ticks(VRuler);
	gtk_ruler_draw_pos(VRuler);
	gtk_widget_show((GtkWidget *)VRuler);
	break;
      } 
    }
  return FALSE;
}



void
on_InternalPoint_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
  sprintf(Buffer,"%.4e%+.4ei",XPos,YPos);
  gtk_entry_set_text(GTK_ENTRY(widget),Buffer);

}



gboolean
on_Level_expose_event                  (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  gdk_draw_pixmap(widget->window,
                  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                  LevelPixmap,
                  event->area.x, event->area.y,
                  event->area.x, event->area.y,
                  event->area.width, event->area.height);
  return FALSE;
}


gboolean
on_Level_configure_event               (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{
  if (LevelPixmap)
     gdk_pixmap_unref(LevelPixmap);

  LevelPixmap = gdk_pixmap_new(widget->window,
			       widget->allocation.width,
			       widget->allocation.height,
			       -1);
  RedrawAllCurves();
  return FALSE;
}

gboolean
on_machines_expose_event                  (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  gdk_draw_pixmap(widget->window,
                  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                  MachinePixmap,
                  event->area.x, event->area.y,
                  event->area.x, event->area.y,
                  event->area.width, event->area.height);
  return FALSE;
}


gboolean
on_machines_configure_event               (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{
  if (MachinePixmap)
     gdk_pixmap_unref(MachinePixmap);

  MachinePixmap = gdk_pixmap_new(widget->window,
			       widget->allocation.width,
			       widget->allocation.height,
			       -1);
  gdk_draw_rectangle (MachinePixmap,
                      widget->style->black_gc,
                      TRUE,
                      0, 0,
                      widget->allocation.width,
                      widget->allocation.width);
  RedrawMachines(NULL);
  return FALSE;
}


gboolean
on_ZoomIn_event                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  Action=ZoomIn;
  return FALSE;
}


gboolean
on_None_event                          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  Action=NULL;
  return FALSE;
}


gboolean
on_ZoomOut_event                       (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  Action=ZoomOut;
  return FALSE;
}


gboolean
on_Compute_event                       (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  Action=Compute_Sz_Window;
  return FALSE;
}


void
on_ComputeEigs_OK_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkTable *table1=(GtkTable *)user_data;
  GList *tmp;
  GtkTableChild *w;
  float Re,Im,eps;
  long nev,ncv,maxit;

  tmp=g_list_first(table1->children);
  while(tmp)
    {
      w=(GtkTableChild *) tmp->data;
      if (strcmp(w->widget->name,"nev")==0)
	if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%ld",&nev)!=1)
	  return;
      if (strcmp(w->widget->name,"ncv")==0)
	if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%ld",&ncv)!=1)
	  return;
      if (strcmp(w->widget->name,"maxit")==0)
	if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%ld",&maxit)!=1)
	  return;
      if (strcmp(w->widget->name,"eps")==0)
	if (sscanf(gtk_entry_get_text(GTK_ENTRY(w->widget)),
		   "%lf",&eps)!=1)
	  return;
      if (strcmp(w->widget->name,"Point")==0)
	if (ProcessComplex((char *) gtk_entry_get_text(GTK_ENTRY(w->widget)),&Re,&Im)==-1)
	  return;
      tmp=g_list_next(tmp);
    }
  ComputeEigs(Re,Im,nev,ncv,maxit,eps);
}


void
on_ComputeEigs_Cancel_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy((GtkWidget *)user_data);
}


void
on_compute_eigenvalues_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *w;

  w=create_window5();
  gtk_widget_show(w);

}


gboolean
CloseConnection                        (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  DisconnectFromMainMaster();
  return FALSE;
}

static int Saved;

void
on_Save_as_filesel_ok_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  Saved=SaveLevelCurves(gtk_file_selection_get_filename((GtkFileSelection *)user_data));
}

void
on_Save_as_Cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  if (Saved)
    gtk_widget_destroy(user_data);
}

void
on_Save_as_cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(user_data);
}

void
on_Hostname_realize                    (GtkWidget       *widget,
                                        gpointer         user_data)
{
  char *GetCurHostName();

  gtk_entry_set_text(GTK_ENTRY(widget),GetCurHostName());
}


void
on_PortNumber_realize                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
  char *GetCurPort();

  gtk_entry_set_text(GTK_ENTRY(widget),GetCurPort());
}


void
on_open_filesel_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  LoadLevelCurves(gtk_file_selection_get_filename((GtkFileSelection *)user_data));
  gtk_widget_destroy(user_data);
}


void
on_open_filesel_cancel_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(user_data);
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *w;
  w=create_dialog2 ();
  gtk_widget_show(w);
}

