#include <malloc.h>
#include <stdio.h>
#include "list.h"


struct Chained
{
  void *Data;
  struct Chained *Next;
};

struct List
{
  int Count;
  struct Chained *First,*Last;
};

void *CreateEmptyList()
{
  struct List *Tmp;

  Tmp=(struct List *)malloc(sizeof(struct List));
  Tmp->Count=0;
  Tmp->First=Tmp->Last=NULL;
  return (void *)Tmp;
}

int AddLast(void *Data,int count,void *List)
{
  struct List *Tmp=List;

  if (Tmp->Count==0)
      Tmp->First=Tmp->Last=(struct Chained *)malloc(sizeof(struct Chained));
  else
    {
      Tmp->Last->Next=(struct Chained *)malloc(sizeof(struct Chained));
      Tmp->Last=Tmp->Last->Next;
    }
  Tmp->Last->Data=malloc(count);
  Tmp->Last->Next=NULL;
  memcpy(Tmp->Last->Data,Data,count);
  Tmp->Count++;
  return 1;
}

int AddFirst(void *Data,int count,void *List)
{
  struct List *Tmp=List;
  struct Chained *p;

  p=Tmp->First;
  Tmp->First=(struct Chained *)malloc(sizeof(struct Chained));
  Tmp->First->Next=p;
  Tmp->First->Data=malloc(count);
  memcpy(Tmp->First->Data,Data,count);
  if (Tmp->Count==0)
    Tmp->Last=Tmp->First;
  Tmp->Count++;
  return 1;
}

int AddPos(int Pos,void *Data,int count,void *List)
{
  struct List *Tmp=List;
  struct Chained *p,*q;
  int i;
  if (Pos<=1)
    return AddFirst(Data,count,List);
  if (Pos>Tmp->Count)
    return AddLast(Data,count,List);
  p=Tmp->First;
  for(i=0;i<Pos;i++)
    {
      q=p;
      p=p->Next;
    }
  q->Next=(struct Chained *)malloc(sizeof(struct Chained));
  q->Next->Next=p;
  q->Next->Data=malloc(count);
  memcpy(q->Next->Data,Data,count);
  Tmp->Count++;
  return 1;
}

int RemoveFirst(void *Data,int count,void *List)
{
  struct List *Tmp=List;
  struct Chained *p;

  if (Tmp->Count==0)
    return 0;
  p=Tmp->First;
  Tmp->First=Tmp->First->Next;
  memcpy(Data,p->Data,count);
  free(p->Data);
  free(p);
  Tmp->Count--;
  return 1;
}

int ListCount(void *List)
{
  struct List *Tmp=(struct List *)List;
  return Tmp->Count;
}

void DestroyList(void *List)
{
  struct List *t=(struct List *)List;
  struct Chained *tmp;

  while(t->First)
    {
      tmp=t->First;
      t->First=tmp->Next;
      free(tmp->Data);
      free(tmp);
    }
  free(t);
}

void ForAllData(void *List,int (*f)(void *,void *),void *Data)
{
  struct List *l=(struct List *)List;
  struct Chained *t=l->First;

  while(t)
    {
      if ((*f)(t->Data,Data))
	return;
      t=t->Next;
    }
}

void *GetFirstDataAdress(void *l)
{
  if (l==NULL || ((struct List *)l)->First==NULL)
    return NULL;
  return (void *) (((struct List *)l)->First->Data);
}

void *GetLastDataAdress(void *l)
{
  if (l==NULL || ((struct List *)l)->Last==NULL)
    return NULL;
  return (void *)(((struct List *)l)->Last->Data);
}
