#include "sparse.h"
#include "eigs.h"
#include <stdio.h>

int Eigs(void *ExtA,Complex z,long nev,long ncv,
	 long maxitr,double tol,doublecomplex *d__)
{
  long it;
  static char bmat[]="I";
  static integer mode, info;
  static logical rvec;
  static integer ierr;
  static integer n;
  static doublecomplex *v, sigma;
  static char which[]="SM";
  static doublecomplex *resid;
  static doublecomplex *workd;
  static integer ipntr[14];
  static doublecomplex *workl,*w;
  static doublereal *rwork;
  static integer iparam[11];
  static logical *select;
  static integer ishfts;
  extern int znaupd_();
  extern int zneupd_();
  static integer lworkl;
  static doublecomplex *workev;
  static integer ido;
  void *A;

  z.i=-z.i;
  z.r=-z.r;
  n=SparseColumns(ExtA);
  A=SparseAdd_zI(ExtA,z); 

  resid=(doublecomplex*)malloc(n*sizeof(doublecomplex));
  w=(doublecomplex*)malloc(n*sizeof(doublecomplex));
  v=(doublecomplex*)malloc(n*ncv*sizeof(doublecomplex));
  workd=(doublecomplex*)malloc(3*n*sizeof(doublecomplex));
  lworkl=3*ncv*ncv+5*ncv;
  workl=(doublecomplex*)malloc(lworkl*sizeof(doublecomplex));
  rwork=(doublereal*)malloc(ncv*sizeof(doublereal));
  workev=(doublecomplex *)malloc(2*ncv*sizeof(doublecomplex));
  select=(logical *)malloc(ncv*sizeof(logical));
  lworkl = ncv * ncv * 3 + ncv * 5;
  ido = 0;
  info = 0;
  
  ishfts = 1;
  mode = 1;
  
  iparam[0] = ishfts;
  iparam[2] = maxitr;
  iparam[6] = mode;
  rvec = TRUE_;
  it=0;
  while(1)
    {
      it++;
      znaupd_(&ido, bmat, &n, which, &nev, &tol, resid, 
	      &ncv, v, &n, iparam, ipntr, workd, workl, 
	      &lworkl, rwork, &info);
      if (ido == -1 || ido == 1) 
	{
	  SparseVect(A,'N',&workd[ipntr[0] - 1],&workd[ipntr[1]-1],NULL);
	  continue;
	}
      if (info < 0) 
	{
	  SparseDestroy(A);
	  free(resid);
	  free(w);
	  free(v);
	  free(workd);
	  free(workl);
	  free(rwork);
	  free(workev);
	  free(select);
	  printf("Info=%ld\n",(long) info);
	  fflush(stdout);
	  return -1;
	}
      else 
	{
	  zneupd_(&rvec, "A", select, d__, v, &n, &sigma, 
		  workev, bmat, &n,which, &nev, &tol, resid, &ncv,
		  v, &n, iparam, ipntr, workd, workl, &lworkl, 
		  rwork, &ierr);
	  if (ierr != 0)
	    {
	      SparseDestroy(A);
	      free(resid);
	      free(w);
	      free(v);
	      free(workd);
	      free(workl);
	      free(rwork);
	      free(workev);
	      free(select);
	      printf("ZNEUPD: IERR=%ld\n",ierr);
	      fflush(stdout);
	      return -1;
	    }
	}
      break;
    }
  SparseDestroy(A);
  free(resid);
  free(w);
  free(v);
  free(workd);
  free(workl);
  free(rwork);
  free(workev);
  free(select);
  if (info == 1) 
    {
      printf(" Maximum number of iterations reached.\n");
      fflush(stdout);
      return -1;
    }
  if (info == 3) 
    {
      printf(" No shifts could be applied during implicit Arnoldi\n");
      printf("update, try increasing NCV.");
      fflush(stdout);
      return -1;
    }
  for(it=0;it<nev;it++)
    {
      d__[it].r=d__[it].r-z.r;
      d__[it].i=d__[it].i-z.i;
    }
  return 1;
}
