#ifndef LEVELCURVE
#define LEVELCURVE

#include "complex.h"
#include "messages.h"

struct ProcInfo
{
  void *LevelCurve;
  void *Segment;
};

int CreateLevelCurve(Complex zi,double Tau,double Sigma,
		     double SigmaPrec,long SigmaMaxIt,
		     double SplitPrec,char IsReal,char Method,double angle);
void PrintLevelCurve(int Id);
int SaveLevelCurve(int Id,char *filename);
int DestroyLevelCurve(int Id);
int LevelID(void *L);
int SetLevelCurveProc(int Id,int MinP,int MaxP);
int SetLevelCurveAllProc(int Id);
int SetLevelCurvePriority(int Id,int Priority);
void LimitLevelCurve2Triangles(int Id,int bool);


int GetMasterMessage(int Processor,struct MasterMsg *Msg,
		     int *Tag,struct ProcInfo *P);
int ProcessSlaveMessage(int Tag,struct SlaveMsg *Msg,struct ProcInfo *Proc);
void SetSocketHandle(int s);

#endif
