#include "messages.h"
#include "mpi.h"


void RegisterMessages(MPI_Datatype *M_Msg,MPI_Datatype *S_Msg)
{
  int blen[10];
  MPI_Aint indices[10];
  MPI_Datatype oldtypes[10];
  Complex z;
  MPI_Datatype MPIComplex;
  struct MasterMsg m_msg;
  struct SlaveMsg s_msg;

  /*   Register Complex ....*/

  blen[0]=1; indices[0]=0;oldtypes[0]=MPI_DOUBLE;
  blen[1]=1; indices[1]=((void*)&z.i)-((void *)&z);oldtypes[1]=MPI_DOUBLE;
  blen[2]=1; indices[2]=sizeof(Complex);oldtypes[2]=MPI_UB;
  MPI_Type_struct(3,blen,indices,oldtypes,&MPIComplex);

  blen[0]=1; indices[0]=0;oldtypes[0]=MPIComplex;
  blen[1]=1; indices[1]=((void*)&m_msg.z2)-((void*)&m_msg);oldtypes[1]=MPIComplex;
  blen[2]=1; indices[2]=((void*)&m_msg.Sigma)-((void*)&m_msg);oldtypes[2]=MPI_DOUBLE;
  blen[3]=1; indices[3]=((void*)&m_msg.SigmaPrec)-((void*)&m_msg);oldtypes[3]=MPI_DOUBLE;
  blen[4]=1; indices[4]=((void*)&m_msg.SplitPrec)-((void*)&m_msg);oldtypes[4]=MPI_DOUBLE;
  blen[5]=1; indices[5]=((void*)&m_msg.SigmaMaxIt)-((void*)&m_msg);oldtypes[5]=MPI_LONG;
  blen[6]=1; indices[6]=((void*)&m_msg.Method)-((void*)&m_msg);oldtypes[6]=MPI_CHAR;
  blen[7]=1; indices[7]=sizeof(m_msg);oldtypes[7]=MPI_UB;
  MPI_Type_struct(8,blen,indices,oldtypes,M_Msg);

  blen[0]=1; indices[0]=0;oldtypes[0]=MPIComplex;
  blen[1]=1; indices[1]=((void*)&s_msg.ze)-((void*)&s_msg);oldtypes[1]=MPIComplex;
  blen[2]=1; indices[2]=((void*)&s_msg.Status)-((void*)&s_msg);oldtypes[2]=MPI_CHAR;
  blen[3]=1; indices[3]=((void*)&s_msg.Sigma)-((void*)&s_msg);oldtypes[3]=MPI_DOUBLE;
  blen[4]=1; indices[4]=((void*)&s_msg.It)-((void*)&s_msg);oldtypes[4]=MPI_LONG;
  blen[5]=1; indices[5]=((void*)&s_msg.xi)-((void*)&s_msg);oldtypes[5]=MPI_LONG;
  blen[6]=1; indices[6]=((void*)&s_msg.yi)-((void*)&s_msg);oldtypes[6]=MPI_LONG;
  blen[7]=1; indices[7]=((void*)&s_msg.xe)-((void*)&s_msg);oldtypes[7]=MPI_LONG;
  blen[8]=1; indices[8]=((void*)&s_msg.ye)-((void*)&s_msg);oldtypes[8]=MPI_LONG;
  blen[9]=1; indices[9]=sizeof(s_msg);oldtypes[9]=MPI_UB;
  MPI_Type_struct(10,blen,indices,oldtypes,S_Msg);
}

  
