#ifndef MESSAGES
#define MESSAGES

#include "sparse.h"
#include "mpi.h"

#define MATRIX_DIM_TAG    0
#define A_COL_TAG         1
#define A_LIN_TAG         2
#define A_VAL_TAG         3

#define Z_TAG    	  4
#define Z1_TAG            5
#define ENDPROG_TAG       6
#define INTERVAL_TAG      7
#define STARTUP_TAG       8
#define EIGS_TAG          9

struct MasterMsg
{
  Complex z1;
  Complex z2;
  double Sigma;
  double SigmaPrec;
  double SplitPrec;
  long SigmaMaxIt;
  char Method;
};

struct SlaveMsg
{
  Complex z;
  Complex ze;
  char Status;
  double Sigma;
  long It;
  long xi,yi,xe,ye;
};

void RegisterMessages(MPI_Datatype *M_Msg,MPI_Datatype *S_Msg);

#endif
