#include <malloc.h>
#include "points.h"



struct Arbre
{
  long x,y;
  double f;
  struct Arbre *fg,*fd;
};


struct PointList
{
  double Tau;
  double Eps;
  struct Arbre *racine;
  struct PointList *Next;
};

struct PointList *list=NULL;

int SearchTree(struct Arbre *a,long x,long y,double *f)
{
  if (a==NULL)
    return 0;
  if (x==a->x && y==a->y)
    {
      *f=a->f;
      return 1;
    }
  else
    if (x+y<a->x+a->y)
      return SearchTree(a->fg,x,y,f);
    else
      return SearchTree(a->fd,x,y,f);
}


int Lookup(long x,long y,double Tau,double *f,double Eps)
{
  struct PointList *tmp=list;

  while (tmp && tmp->Tau !=Tau && tmp->Eps!=Eps)
    tmp=tmp->Next;
  if (tmp==NULL)
    return 0;
  return SearchTree(tmp->racine,x,y,f);
}

struct Arbre *AddTree(struct Arbre *racine,long x,long y,double *f)
{
  if (racine==NULL)
    {
      racine=(struct Arbre *)malloc(sizeof(struct Arbre));
      racine->x=x;
      racine->y=y;
      racine->f=*f;
      racine->fg=racine->fd=NULL;
      return racine;
    }
  if (racine->x==x && racine->y==y)
    {
      *f=racine->f;
      return racine;
    }
  if (x+y<racine->x+racine->y)
    racine->fg=AddTree(racine->fg,x,y,f);
  else
    racine->fd=AddTree(racine->fd,x,y,f);
  return racine;
}

void Add(long x,long y,double Tau,double *f,double Eps)
{
  struct PointList *tmp=list;


  while (tmp!=NULL && tmp->Tau !=Tau && tmp->Eps!=Eps)
    tmp=tmp->Next;
  if (tmp==NULL)
    {
      tmp=list;
      list=(struct PointList *)malloc(sizeof(struct PointList));
      list->Next=tmp;
      list->Tau=Tau;
      list->Eps=Eps;
      list->racine=AddTree(NULL,x,y,f);
    }
  else
    tmp->racine=AddTree(tmp->racine,x,y,f);
}
