#include <stdlib.h>
#include <stdio.h>


static quicksort(unsigned long *Keys,
		 unsigned long *Index,
		 unsigned long From,
		 unsigned long To,
		 unsigned long Weight)
{
  long i=From,j=To,tmp;
  if (Weight==0 || To<=From)
    return;
  while (i<=j)
    {
      for(;i<=j;i++)
	if (Keys[Index[i]] & Weight)
	  break;
      for(;i<=j;j--)
	if ((Keys[Index[j]] & Weight)==0)
	  break;
      if (i<j)
	{
	  tmp=Index[i];
	  Index[i]=Index[j];
	  Index[j]=tmp;
	  i++;j--;
	}
    }
  if (i!=j+1)
    printf("i=%d,j=%d\n",i,j);
  quicksort(Keys,Index,From,j,Weight>>1);
  quicksort(Keys,Index,i,To,Weight>>1);
}

void QuickSortKeys(unsigned long *Keys,unsigned long *Index,unsigned long n)
     /* This Function builds the index to sort the keys in assending order 

	Keys (Input): Array of dimension n.
	     The keys to be sorted.
	Index (Output):Array of dimension n.
	     Then indexes of the sorted array.
	n (Input): The dimension of Keys and Index.
     */
{
  unsigned long i,max;
  unsigned long weight;
  max=Keys[0];
  Index[0]=0;
  for(i=1;i<n;i++)
    {
      Index[i]=i;
      if (Keys[i]>max)
	     max=Keys[i];
    }
  weight=1 << (8*sizeof(unsigned long)-1);
  while(weight>max)
    weight=weight>>1;
  quicksort(Keys,Index,0,n-1,weight<<1);
}

