#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/resource.h>
#include <math.h>
#include "mpi.h"
#include "messages.h"

main(int argc,char **argv)
{
 int Size,Rank,i;
 long j=1;
 MPI_Datatype M_Msg,S_Msg;
 struct SlaveMsg Msg;

 MPI_Init(&argc,&argv);
 MPI_Comm_size(MPI_COMM_WORLD,&Size);
 MPI_Comm_rank(MPI_COMM_WORLD,&Rank);
 RegisterMessages(&M_Msg,&S_Msg);
 if (Rank==0)
   {
     Msg.z.r=1.0,Msg.z.i=2.0;
     Msg.ze.r=3,Msg.ze.i=4;
     Msg.Status='S';
     Msg.Sigma=1e-5;
     Msg.It=100;
     MPI_Send(&Msg,1,S_Msg,1,0,MPI_COMM_WORLD);
   }
 else
   {
     MPI_Status St;
     MPI_Recv(&Msg,1,S_Msg,0,0,MPI_COMM_WORLD,&St);
     printf("z=%e%+ei\n",Msg.z.r,Msg.z.i);
     printf("ze=%e%+ei\n",Msg.ze.r,Msg.ze.i);
     printf("Sigma=%e\n",Msg.Sigma);
     printf("Status=%c\n",Msg.Status);
     printf("It=%ld\n",Msg.It);
   }
 MPI_Finalize();
}  
